package cn.iocoder.yudao.module.pms.service.iotprojecttask;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.pms.controller.admin.iotprojecttask.vo.IotProjectTaskPageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.iotprojecttask.vo.IotProjectTaskSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.iotprojecttask.IotProjectTaskDO;

import javax.validation.Valid;
import java.util.Collection;
import java.util.List;

/**
 * 项目信息任务拆分 Service 接口
 *
 * @author 超级管理员
 */
public interface IotProjectTaskService {

    /**
     * 创建项目信息任务拆分
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createIotProjectTask(@Valid IotProjectTaskSaveReqVO createReqVO);


    Boolean createIotProjectTaskList(List<IotProjectTaskSaveReqVO> list);

    /**
     * 更新项目信息任务拆分
     *
     * @param updateReqVO 更新信息
     */
    void updateIotProjectTask(@Valid IotProjectTaskSaveReqVO updateReqVO);

    void updateIotProjectTaskList(List<IotProjectTaskSaveReqVO> list);

    /**
     * 删除项目信息任务拆分
     *
     * @param id 编号
     */
    void deleteIotProjectTask(Long id);

    /**
     * 获得项目信息任务拆分
     *
     * @param id 编号
     * @return 项目信息任务拆分
     */
    IotProjectTaskDO getIotProjectTask(Long id);

    /**
     * 获得项目信息任务拆分分页
     *
     * @param pageReqVO 分页查询
     * @return 项目信息任务拆分分页
     */
    PageResult<IotProjectTaskDO> getIotProjectTaskPage(IotProjectTaskPageReqVO pageReqVO);

    /**
     * 项目信息任务列表
     *
     * @param pageReqVO 列表查询
     * @return 项目信息任务列表
     */
    List<IotProjectTaskDO> projectTasks(IotProjectTaskPageReqVO pageReqVO);

    PageResult<IotProjectTaskDO> getIotProjectTaskPage1(IotProjectTaskPageReqVO pageReqVO,Collection<Long> deptIds);


    PageResult<IotProjectTaskDO> taskList(IotProjectTaskPageReqVO taskDO,Collection<Long> deptIds);

    /**
     * 移动端查询 任务列表
     * @param taskDO
     * @param deptIds
     * @return
     */
    PageResult<IotProjectTaskDO> appTaskList(IotProjectTaskPageReqVO taskDO,Collection<Long> deptIds);

    /**
     * 查询所有任务井号信息 过滤数据权限
     *
     * @param pageReqVO 列表查询
     * @return 项目信息任务列表
     */
    List<IotProjectTaskDO> taskWellNames(IotProjectTaskPageReqVO pageReqVO);

    /**
     * 基于新建的任务井号 生成指定日期的日报 (默认生成当天的日报)
     *
     * @param reqVO 请求参数 任务井id 日报日期
     * @return 生成日报数量
     */
    Long generateReport(IotProjectTaskPageReqVO reqVO);
}